/* ----------
 * 
 * ---------- */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

#define BUFFSZ		(1024)
#define EXEC_FETCH	("/usr/bin/fetchmail")

/* ɥκ */
void entry_init(void);
/* ܥ󤬥å줿Ȥν */
void apply_button_clicked(GtkWidget *widget, gpointer data);
/* ꥢܥ󤬥å줿Ȥν */
void clr_button_clicked(GtkWidget *widget, gpointer data);
/* åȥܥ󤬥å줿Ȥν */
void quit_button_clicked(GtkWidget *widget, gpointer data);

/* Хѿ */
GtkWidget *entry;

/* ----------
   
* ---------- */
void entry_init(void)
{
    GtkWidget *window;
    GtkWidget *table;
    GtkWidget *button;

    /* ɥ widget  */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_signal_connect(GTK_OBJECT(window), "destroy",
		       GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
    gtk_window_set_title(GTK_WINDOW(window), "xfetchmail");
    gtk_container_border_width(GTK_CONTAINER(window), 5);

    /* 2x5 Υơ֥ widget  */
    table = gtk_table_new(2, 5, TRUE);
    gtk_container_add(GTK_CONTAINER(window), table);
    gtk_widget_show(table);

    /* ׻ɽ widget  */
    entry = gtk_entry_new();
    gtk_table_attach_defaults(GTK_TABLE(table), entry, 0, 5, 0, 1);
    gtk_widget_show(entry);

    /* ܥ0 widget κ */
    button = gtk_button_new_with_label("Apply");
    gtk_table_attach_defaults(GTK_TABLE(table), button, 0, 1, 1, 2);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(apply_button_clicked), (gpointer) 0);
    gtk_widget_show(button);

    /* ꥢܥ widget κ */
    button = gtk_button_new_with_label("Clear");
    gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 1, 2);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(clr_button_clicked), NULL);
    gtk_widget_show(button);

    /* ꥢܥ widget κ */
    button = gtk_button_new_with_label("Quit");
    gtk_table_attach_defaults(GTK_TABLE(table), button, 4, 5, 1, 2);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(quit_button_clicked), NULL);
    gtk_widget_show(button);

    /* ɥ widget ɽ */
    gtk_widget_show(window);
    return;
}

/* ----------
 * fetchmail ¹Ԥη̤
 * ---------- */
static int  GetFetchmailResult (char *buf, int size)
{
    pid_t   pid;
    int     piped[2];
    int     red;

    // create pipe
    if (pipe(piped) < 0) {
        perror("pipe");
        exit(1);
    }

    // create child process to exec
    pid = fork();
    if (pid < 0) {
        perror("fork");
        exit(1);
    } else if (pid == 0) {
        /* child process */
        /* ɤ߹ߥѥפĤ */
        close(piped[0]);

        /* ɸϤѥפ˳Ƥ */
        close(1);
        dup(piped[1]);
        close(piped[1]);

        /* Ҥν */
        execl(EXEC_FETCH, EXEC_FETCH, NULL);
        _exit(0);
    }
    
    /* 񤭹ߥѥפĤ */
    close(piped[1]);
    
    /* ƥץ */
    memset(buf, 0, size);

    red = read(piped[0], buf, size);

#ifdef DEBUG
    fprintf(stderr, "read bytes %d\n", red);
#endif
    if (red <= 0) {
	return -1;
    }

    return red;
}

    
/* ----------
   callback function: digit_button_clicked
   ܥ󤬥å줿Ȥν
* ---------- */
void apply_button_clicked(GtkWidget *window, gpointer data)
{
    char    buf[BUFFSZ];

    /* fetchmail η̤ */
    GetFetchmailResult(buf, BUFFSZ);
	
    /* ̤ɽ */
    gtk_entry_set_text(GTK_ENTRY(entry), buf);
}


/* ----------
   callback function
   ꥢܥ󤬥å줿Ȥν
* ---------- */
void clr_button_clicked(GtkWidget *widget, gpointer data)
{
    /* ɽΥꥢ */
    gtk_entry_set_text(GTK_ENTRY(entry), "");
}

/* ----------
   callback function
   åȥܥ󤬥å줿Ȥν
* ---------- */
void quit_button_clicked(GtkWidget *widget, gpointer data)
{
    // λ
    gtk_main_quit();
}


/* ----------
  main
 * ---------- */
int main(int argc, char *argv[])
{
    /*  */
    /*  gtk_set_locale();*/
    gtk_init(&argc, &argv);

    /*  */
    entry_init();

    /* GTK ٥Ȥγ*/
    gtk_main();

    return 0;
}

/* eof */
